<?php

/****************************************/
/* Advanced Nuke Backup                 */
/* By: Josh Weber (ztgotcha@hotmail.com)*/
/* http://s88357202.onlinehome.us/      */
/* Copyright  2004 by Josh Weber       */
/****************************************/

require_once("mainfile.php");

function index(){
    include("header.php");
    opentable();
    echo "<center><form action=\"anbinstall.php\" method=\"post\">"
        ."<font class=\"title\">Installation d'Advanced Nuke Backup</font><br><br>"
        ."<select name=\"sw\">"
        ."<option value=\"newinstall\">Nouvelle installation</option>"
        ."<option value=\"anbupdate\">Mise  jour de la version 1.0b</option>"
        ."</select>"
        ."&nbsp;<input type=\"submit\" name=\"submit\" value=\"Installer\"><br><br>"
        ."</form>"
        ."Site Web : <a href=\"http://s88357202.onlinehome.us\">Advanced Nuke Backup</a><br><br></center>";
    closetable();
    include("footer.php");
}

function newinstall(){
    global $prefix, $db;
    $sql = "CREATE TABLE `".$prefix."_advbackup` (
        `id` int(11) NOT NULL default '0',
        `backupdir` varchar(100) NOT NULL default 'backup',
        `mail_to` varchar(255) NOT NULL default '',
        `mail_from` varchar(255) NOT NULL default '',
        `excludes` varchar(255) NOT NULL default '',
        `lastdb` varchar(25) default NULL,
        `lastfile` varchar(25) default NULL,
        `autostate` varchar(4) NOT NULL default '',
        `autoinc` int(11) NOT NULL default '48',
        `autolast` int(22) NOT NULL default '0',
        `autogzip` varchar(4) NOT NULL default '',
        `automail` varchar(4) NOT NULL default '',
        `autodel` varchar(10) NOT NULL default '',
        PRIMARY KEY  (`id`)
        ) TYPE=MyISAM;";
    $result1 = $db->sql_query($sql);

    $sql2 = "INSERT INTO `".$prefix."_advbackup` VALUES (1, 'backup', '', '', 'db', '', '', '', '48', '0', '', '', '');";
    $result2=$db->sql_query($sql2);

    include("header.php");
    opentable();
    if ($result1 && $result2){
        echo "<center>Advanced Nuke Backup a t install avec succs !</center>";
        echo "<center>Maintenant, vous devez proteger votre rpertoire de sauvegarde avec un mot de passe !</center>";
        echo "<center><a href=\"anbinstall.php?sw=setbackupdir\">Etape suivante</a></center>";
    }else{
        echo "Une erreur est survenue ! R-essayer... [ <a href=\"javascript:history.go(-1)\">Retour</a> ]";
        ;
    }
    closetable();
    include("footer.php");
}

function anbupdate(){
    global $prefix, $db;
    $result = $db->sql_query("SELECT * FROM ".$prefix."_advbackup where id='1'");
    $row = $db->sql_fetchrow($result);
    $excludes = $row['excludes'];
    $strip = str_replace("--exclude=", "", $excludes);
    $exclude = "$strip\n";

    $sql = "ALTER TABLE `".$prefix."_advbackup` 
        ADD `autostate` varchar(4) NOT NULL default '',
        ADD `autoinc` int(11) NOT NULL default '48',
        ADD `autolast` int(22) NOT NULL default '0',
        ADD `autogzip` varchar(4) NOT NULL default '',
        ADD `automail` varchar(4) NOT NULL default '',
        ADD `autodel` varchar(10) NOT NULL default '';";

    $result1=$db->sql_query($sql);

    $sql2 = "UPDATE `".$prefix."_advbackup` SET excludes='$exclude';";

    $result2=$db->sql_query($sql2);

    include("header.php");
    opentable();
    if ($result1 && $result2){
        echo "<center>Advanced Nuke Backup a t install avec succs !</center>";
        echo "<center>Maintenant, vous devez proteger votre rpertoire de sauvegarde avec un mot de passe !</center>";
        echo "<center><a href=\"anbinstall.php?sw=setbackupdir\">Etape suivante</a></center>";
        echo "<center><a href=\"admin.php?op=anbmain\">Finir maintenant</a> sans protection du rpertoire !</center>";
    }else{
        echo "Une erreur est survenue ! R-essayer... [ <a href=\"javascript:history.go(-1)\">Retour</a> ]";
    }
    closetable();
    include("footer.php");
}

function setbackupdir(){
    global $prefix, $db;
    $result = $db->sql_query("SELECT backupdir FROM ".$prefix."_advbackup where id='1'");
    $row = $db->sql_fetchrow($result);
    $backupdir = $row['backupdir'];
    include("header.php");
    opentable();

    echo "Maintenant, vous devez dfinir quel rpertoire protger.<br>"
        ."Si le rpertoire n'existe pas, il sera cre<br><br>"
        ."<form action=\"anbinstall.php\" method=\"post\">"
        ."Rpertoire de sauvegarde : <input type=\"text\" name=\"backupdir\" value=\"$backupdir\">"
        ."<input type=\"hidden\" name=\"sw\" value=\"setbackup\">"
        ."&nbsp;<input type=\"submit\" name=\"submit\" value=\"Appliquer\">"
        ."</form>";
        
    closetable();
    include("footer.php");
}

function setbackup($backupdir){
    global $prefix, $db;
    $result = $db->sql_query("UPDATE ".$prefix."_advbackup SET backupdir='$backupdir' where id='1'");
    if($result){
        if (!is_dir("$backupdir")){
            mkdir("$backupdir", 0755);
        }
        include("header.php");
        opentable();
        echo "<center>Maintenant, entrer le nom et le mot de passe  utiliser avec ce rpertoire !<br><br></center>";
        echo "<center><a href=\"anbinstall.php?sw=protect\">Etape suivante</a></center>";
        closetable();
        include("footer.php");
    }else{
        include("header.php");
        opentable();
        echo "Une erreur est survenue ! R-essayer... [ <a href=\"javascript:history.go(-1)\">Retour</a> ]";
        closetable();
        include("footer.php");
    }
}

function protect(){
    global $prefix, $db, $user;
    $result = $db->sql_query("SELECT * FROM ".$prefix."_advbackup where id='1'");
    $row = $db->sql_fetchrow($result);
    $backupdir = $row['backupdir'];

    include("header.php");
    opentable();
    echo "<font class=\"title\">Entrer le nom et le mot de passe pour le rpertoire $backupdir</font>"
        ."<form action=\"anbinstall.php\" method=\"post\">"
        ."Nom : <input type=\"text\" name=\"name\"><br>"
        ."Mot de passe : <input type=\"password\" name=\"pass\"><br>"
        ."<input type=\"hidden\" name=\"sw\" value=\"makehts\">"
        ."&nbsp;<input type=\"submit\" name=\"submit\" value=\"Envoyer\">"
        ."</form>";
    closetable();
    include("footer.php");

}

function makehts($name, $pass, $backupdir){
    global $prefix, $db;
    $result = $db->sql_query("SELECT * FROM ".$prefix."_advbackup where id='1'");
    $row = $db->sql_fetchrow($result);
    $backupdir = $row['backupdir'];

    $pass2 = crypt($pass);
    $data = "$name:$pass2";
    $fd = fopen("$backupdir/.htpasswd", "w");
    $pass = fwrite($fd, $data);
    fclose($fd);

    $path = $_SERVER["PATH_TRANSLATED"];
    $root = ereg_replace("/anbinstall.php", "", $path);
    $data2 = "AuthUserFile $root/$backupdir/.htpasswd\n";
    $data2.= "AuthGroupFile /dev/null\n";
    $data2.= "AuthName $backupdir\n";
    $data2.= "AuthType Basic\n";
    $data2.= "require user $name\n\n";
    $data2.= "AddType application/x-zip .gz\n";

    $fd2 = fopen("$backupdir/.htaccess", "w");
    $acc = fwrite($fd2, $data2);
    fclose($fd2);

    if($pass && $acc){
        include("header.php");
        opentable();
        echo "<center>Le rpertoire est maintenant protg par un mot de passe !</center>";
        echo "<center><a href=\"$backupdir\" target=\"blank\">Cliquer pour tester</a></center>";
        echo "<br><center>Note : Des messages d'erreurs de type 403 sont communs !</center>";
        echo "<br><center><a href=\"admin.php?op=anbconfig\">Configuration d'Advanced Nuke Backup</a></center>";
        closetable();
        include("footer.php");
    }

}

switch($sw){

    default:
    index();
    break;

    case "newinstall":
    newinstall();
    break;

    case "anbupdate":
    anbupdate();
    break;

    case "setbackupdir":
    setbackupdir();
    break;

    case "setbackup":
    setbackup($backupdir);
    break;

    case "protect":
    protect();
    break;

    case "makehts":
    makehts($name, $pass, $backupdir);
    break;

}
?>